#include <bits/stdc++.h>
#define REP(i,a) for(int i=0;i<a;i++)
#define ii pair<int,int>
#define valid(x,y,w,h) ((x>=0)&&(x<w)&&(y>=0)&&(y<h))
using namespace std;

char mat[2016][2016];
int sizes[5][5]={{20,100,98,99,100}, {20,100,98,99,100}, {20,100,98,99,100}, {200,1000,980,990,1000}, {1000,200,980,990,1000}};
bool jde[3][5]={{0,0,0,0,0}, {0,1,0,1,0}, {0,0,0,0,0}};

void printmat(int R, int S, string name){
	ofstream file(name.c_str());
	file<<R<<" "<<S<<endl;
	REP(i, R){
		REP(j,S){
			file<<mat[i][j];
		}
		file<<endl;
	}
	file<<endl;
}

void protipriklad(int R){
	assert(R>=20);

	REP(i,R)REP(j,R){
		mat[i][j]='.';
	}
	REP(i,R-2){
		mat[i][i]='#';
	}
	int cara=R/2;
	//if(cara%2==0)cara--;
	for(int i=cara-4;i>=0;i-=2){
		mat[cara][i]=mat[i][cara]='#';
	}

	bool b=0;
	for(int zed=cara+3;zed<R-3;zed+=3){
		if(b==0){
			b=1;
			for(int j=zed;j>=2;j-=2){
				mat[zed][j]=mat[j][zed]='#';
			}
		}
		else{
			b=0;
			for(int j=0;j<zed-4;j+=2){
				mat[zed][j]=mat[j][zed]='#';
			}
		}
	}

	int x=rand()%(cara-8)+4;
	int y=rand()%(x-3);

	mat[y][x]=mat[y][x+1]=mat[y+1][x]=mat[y+1][x+1]='K';

	y=rand()%(cara-8)+4;
	x=rand()%(y-3);

	mat[y][x]=mat[y][x+1]=mat[y+1][x]=mat[y+1][x+1]='T';
}

void hodnezdi(int R, int S, bool jde){
	assert(R>10&&S>10);

	REP(i,R)REP(j,S)mat[i][j]='.';

	mat[0][0]=mat[0][1]=mat[1][0]=mat[1][1]='K';
	mat[0][S-1]=mat[0][S-2]=mat[1][S-1]=mat[1][S-2]='T';

	for(int i=0;i<R-3;i+=2){
		mat[i][2]=mat[i][S-3]='#';
	}
	for(int i=2;i<S-2;i+=2){
		mat[R-3][i]='#';
	}
	mat[R-1][S/2]='#';
	if(!jde)mat[R-1][S/2+1]='#';

}

void nejdeprojit(int R, int S){
	assert(R>10&&S>10);

	REP(i,R)REP(j,S){
		mat[i][j]='.';
		if(rand()%10==0)mat[i][j]='#';
	}
	
	int x=rand()%(S/2-3);
	int y=rand()%(R-3);
	mat[y][x]=mat[y+1][x]=mat[y][x+1]=mat[y+1][x+1]='T';
	x=rand()%(S/2-5)+S/2+3;
	y=rand()%(R-3);
	mat[y][x]=mat[y+1][x]=mat[y][x+1]=mat[y+1][x+1]='K';

	REP(i,R)mat[i][S/2]=mat[i][S/2+1]='#';
	
}

void nahoda(int R, int S, int p){
	assert(R>10&&S>10);
	REP(i, R)REP(j, S)mat[i][j]=(((rand()%100)<p) ? '#' : '.');
	int s=rand()%(S-1);
	int r=rand()%(R-1);
	mat[r][s]=mat[r+1][s]=mat[r][s+1]=mat[r+1][s+1]='T';
	while(true){
		s=rand()%(S-1);
		r=rand()%(R-1);
		if(mat[r][s]=='T'||mat[r+1][s]=='T'||mat[r][s+1]=='T'||mat[r+1][s+1]=='T')continue;
		mat[r][s]=mat[r+1][s]=mat[r][s+1]=mat[r+1][s+1]='K';
		break;
	}
}

void meander (int RS)
{
  REP(i, RS)REP(j, RS) mat[i][j]='.';
  for (int i = 4; i < RS - 4; i += 3)
    {
      int f = i % 2 ? 0 : 2;
      int t = i % 2 ? RS - 2 : RS;

      for (int j = f; j < t; j += 2)
	mat[i][j] = '#';
    }

  mat[0][0] = mat[0][1] = mat[1][0] = mat[1][1] = 'T';
  mat[RS-1][RS-1] = mat[RS-1][RS-2] = mat[RS-2][RS-1] = mat[RS-2][RS-2] = 'K';

  mat[5 + (RS / 6) * 3][RS/2] = '#';
}

void vypis(int group, int gid, char letter, int R, int S, bool jde=0, int p=0){
	stringstream name;
	name<<"zed"<<group<<letter<<".in";
	cout<<"Generating file "<<name.str()<<endl;
	
	switch(gid){
		case 0: protipriklad(R); break;
		case 1: hodnezdi(R,S,jde); break;
		case 2: nejdeprojit(R,S); break;
		case 3: nahoda(R,S,p); break;
		case 4: meander(R);
	}
	printmat(R, S, name.str());		
}


int main(int argc, char* argv[]){
	srand(0);
	
	REP(t,3){
		REP(i,5){
			vypis(t+4,t,'a'+i,sizes[t][i],sizes[t][i],jde[t][i]);	
		}	
	}
	vypis(6,4,'f', 100, 100);	
	REP(i,5){
		vypis(7,3,'a'+i,sizes[3][i],sizes[4][i],0,i*5);	
	}
	vypis(8,4,'a', 1000, 1000);	
	vypis(9,4,'a', 2000, 2000);	

	FILE *fout = fopen ("zed0a.in", "w");
	fprintf (fout, "4 7\n");
	fprintf (fout, "KK.#.TT\n");
	fprintf (fout, "KK.##TT\n");
	fprintf (fout, "#......\n");
	fprintf (fout, "...#...\n");
	fclose (fout);

	fout = fopen ("zed0b.in", "w");
	fprintf (fout, "4 7\n");
	fprintf (fout, "KK.#.TT\n");
	fprintf (fout, "KK.#.TT\n");
	fprintf (fout, "...#...\n");
	fprintf (fout, "...#...\n");
	fclose (fout);

	fout = fopen ("zed1a.in", "w");
	fprintf (fout, "4 7\n");
	fprintf (fout, "KK#.#TT\n");
	fprintf (fout, "KK#.#TT\n");
	fprintf (fout, ".......\n");
	fprintf (fout, "..#....\n");
	fclose (fout);

	fout = fopen ("zed2a.in", "w");
	fprintf (fout, "5 6\n");
	fprintf (fout, "KK##TT\n");
	fprintf (fout, "KK##TT\n");
	fprintf (fout, "..#...\n");
	fprintf (fout, "...#..\n");
	fprintf (fout, ".....#\n");
	fclose (fout);

	fout = fopen ("zed3a.in", "w");
	fprintf (fout, "10 10\n");
	fprintf (fout, "KK....#...\n");
	fprintf (fout, "KK....#...\n");
	fprintf (fout, "####..#...\n");
	fprintf (fout, "......#...\n");
	fprintf (fout, ".....#....\n");
	fprintf (fout, "..###.....\n");
	fprintf (fout, ".......#..\n");
	fprintf (fout, ".......#..\n");
	fprintf (fout, "########TT\n");
	fprintf (fout, "........TT\n");
	fclose (fout);

	return 0;
}
