//vzdy skusi rozbit jednu zed a pak projde cele bludiste znovu -> O((RS)^2)
#include <bits/stdc++.h>
#define REP(i,a) for(int i=0;i<a;i++)
#define ii pair<int,int>
#define valid(x,y,w,h) ((x>=0)&&(x<w)&&(y>=0)&&(y<h))
using namespace std;

char mat[1016][1016];
int vis[1016][1016];
ii dir[4]={{-1,0},{1,0},{0,-1},{0,1}};
ii square[4]={{0,0},{1,0},{0,1},{1,1}};
int R, S;
ii start, fin, curfree={-2,-2};

inline bool isok(ii u){//souradnice jsou validni a nic na nich neni
	if(!valid(u.first, u.second, R-1, S-1)){
		return 0;
	}
	
	int cnt=0;
	REP(i,4){
		if(mat[u.first+square[i].first][u.second+square[i].second]=='#')cnt++;	
	}
	
	if((curfree.first==u.first || curfree.first==u.first+1) && (curfree.second==u.second || curfree.second==u.second+1))cnt--;
	assert(cnt>=0);
	if(cnt==0){
		return 1;
	}
	return 0;
}

void dfs(ii u){
	REP(i,4){
		ii v = {u.first+dir[i].first, u.second+dir[i].second};
		if(isok(v) && vis[v.first][v.second]==-1){
			vis[v.first][v.second]=i;
			dfs(v);
		}
	}
}

void trypath(){
	REP(i,R)REP(j,S)vis[i][j]=-1;
	dfs(fin);
	if(vis[start.first][start.second]!=-1){
		ii cur=start;
		while(cur!=fin){
			switch(vis[cur.first][cur.second]){
				case 0: printf("D"); cur.first++; break;
				case 1: printf("N"); cur.first--; break;
				case 2: printf("P"); cur.second++; break;
				case 3: printf("L"); cur.second--; break;
			}
		}
		printf("\n");
		exit(0);
	}
}

int main(){
	scanf("%d %d", &R, &S);
	REP(i,R){
		REP(j,S){
			scanf(" %c ", &mat[i][j]);
			if(mat[i][j]=='K'){
				start.first=i;
				start.second=j;
			}
			if(mat[i][j]=='T'){
				fin.first=i;
				fin.second=j;
			}
		}
	}
	start.first--;start.second--;fin.first--;fin.second--;

	trypath();
	//musim bourat
	REP(i,R)REP(j,S){
		if(mat[i][j]=='#'){
			curfree={i,j};
			trypath();
		}
	}
	printf("nelze\n");
}
